"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setField = exports.IterableTreeArrayContent = exports.TreeArrayNode = exports.test_RecursiveObjectPojoMode = exports.test_RecursiveObject_base = exports.test_RecursiveObject = exports.typedObjectValues = exports.singletonSchema = exports.enumFromStrings = exports.adaptEnum = exports.getProxyForField = exports.cursorFromUnhydratedRoot = exports.toFlexConfig = exports.treeNodeApi = exports.getFlexNode = exports.SchemaFactory = exports.InternalSimpleTreeTypes = exports.normalizeFieldSchema = exports.FieldSchema = exports.FieldKind = exports.type = exports.NodeKind = exports.TreeViewConfiguration = exports.TreeConfiguration = void 0;
var tree_js_1 = require("./tree.js");
Object.defineProperty(exports, "TreeConfiguration", { enumerable: true, get: function () { return tree_js_1.TreeConfiguration; } });
Object.defineProperty(exports, "TreeViewConfiguration", { enumerable: true, get: function () { return tree_js_1.TreeViewConfiguration; } });
var schemaTypes_js_1 = require("./schemaTypes.js");
Object.defineProperty(exports, "NodeKind", { enumerable: true, get: function () { return schemaTypes_js_1.NodeKind; } });
Object.defineProperty(exports, "type", { enumerable: true, get: function () { return schemaTypes_js_1.type; } });
Object.defineProperty(exports, "FieldKind", { enumerable: true, get: function () { return schemaTypes_js_1.FieldKind; } });
Object.defineProperty(exports, "FieldSchema", { enumerable: true, get: function () { return schemaTypes_js_1.FieldSchema; } });
Object.defineProperty(exports, "normalizeFieldSchema", { enumerable: true, get: function () { return schemaTypes_js_1.normalizeFieldSchema; } });
const InternalSimpleTreeTypes = __importStar(require("./internalTypes.js"));
exports.InternalSimpleTreeTypes = InternalSimpleTreeTypes;
var schemaFactory_js_1 = require("./schemaFactory.js");
Object.defineProperty(exports, "SchemaFactory", { enumerable: true, get: function () { return schemaFactory_js_1.SchemaFactory; } });
var proxyBinding_js_1 = require("./proxyBinding.js");
Object.defineProperty(exports, "getFlexNode", { enumerable: true, get: function () { return proxyBinding_js_1.getFlexNode; } });
var treeNodeApi_js_1 = require("./treeNodeApi.js");
Object.defineProperty(exports, "treeNodeApi", { enumerable: true, get: function () { return treeNodeApi_js_1.treeNodeApi; } });
var toFlexSchema_js_1 = require("./toFlexSchema.js");
Object.defineProperty(exports, "toFlexConfig", { enumerable: true, get: function () { return toFlexSchema_js_1.toFlexConfig; } });
Object.defineProperty(exports, "cursorFromUnhydratedRoot", { enumerable: true, get: function () { return toFlexSchema_js_1.cursorFromUnhydratedRoot; } });
var proxies_js_1 = require("./proxies.js");
Object.defineProperty(exports, "getProxyForField", { enumerable: true, get: function () { return proxies_js_1.getProxyForField; } });
var schemaCreationUtilities_js_1 = require("./schemaCreationUtilities.js");
Object.defineProperty(exports, "adaptEnum", { enumerable: true, get: function () { return schemaCreationUtilities_js_1.adaptEnum; } });
Object.defineProperty(exports, "enumFromStrings", { enumerable: true, get: function () { return schemaCreationUtilities_js_1.enumFromStrings; } });
Object.defineProperty(exports, "singletonSchema", { enumerable: true, get: function () { return schemaCreationUtilities_js_1.singletonSchema; } });
Object.defineProperty(exports, "typedObjectValues", { enumerable: true, get: function () { return schemaCreationUtilities_js_1.typedObjectValues; } });
// Exporting the schema (RecursiveObject) to test that recursive types are working correctly.
// These are `@internal` so they can't be included in the `InternalClassTreeTypes` due to https://github.com/microsoft/rushstack/issues/3639
var testRecursiveDomain_js_1 = require("./testRecursiveDomain.js");
Object.defineProperty(exports, "test_RecursiveObject", { enumerable: true, get: function () { return testRecursiveDomain_js_1.RecursiveObject; } });
Object.defineProperty(exports, "test_RecursiveObject_base", { enumerable: true, get: function () { return testRecursiveDomain_js_1.base; } });
Object.defineProperty(exports, "test_RecursiveObjectPojoMode", { enumerable: true, get: function () { return testRecursiveDomain_js_1.RecursiveObjectPojoMode; } });
var arrayNode_js_1 = require("./arrayNode.js");
Object.defineProperty(exports, "TreeArrayNode", { enumerable: true, get: function () { return arrayNode_js_1.TreeArrayNode; } });
Object.defineProperty(exports, "IterableTreeArrayContent", { enumerable: true, get: function () { return arrayNode_js_1.IterableTreeArrayContent; } });
var objectNode_js_1 = require("./objectNode.js");
Object.defineProperty(exports, "setField", { enumerable: true, get: function () { return objectNode_js_1.setField; } });
//# sourceMappingURL=index.js.map