/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { ChangeRebaser, GraphCommit, RevisionTag } from "../core/index.js";
import { ChangeEnricherReadonlyCheckout } from "./changeEnricher.js";
/**
 * Utility for producing an enriched commit out of multiple transaction steps
 */
export declare class TransactionEnricher<TChange> {
    private readonly rebaser;
    private readonly enricher;
    private readonly transactionCommits;
    constructor(rebaser: ChangeRebaser<TChange>, enricher: ChangeEnricherReadonlyCheckout<TChange>);
    addTransactionSteps(commit: GraphCommit<TChange>): void;
    getComposedChange(revision: RevisionTag): TChange;
}
//# sourceMappingURL=transactionEnricher.d.ts.map